<?php


function rm_podcast_list_events()
{
/**
 *
 * Lists podcast events
 * 
 * @author  Andy Moyle
 * @param    null
 * @return   html string
 * @version  0.1
 * 
 */    
    global $wpdb;
    $wpdb->show_errors();

    echo'<h2>RM Podcast Events</h2>';
    echo'<a href="'.wp_nonce_url('admin.php?page=rm_podcasts/index.php&amp;action=edit_event','edit_podcast_event').'">Add an Event</a></p>';
            
    //grab files from table
    $results=$wpdb->get_results('SELECT * FROM '.RM_POD_EVE);
    if($results)
    {//results
        $table='<table class="widefat"><thead><tr><th>Edit</th><th>Delete</th><th>Event</th><th>Files</th><th>Shortcode</th></tr></thead>'."\r\n".'<tfoot><tr><th>Edit</th><th>Delete</th><th>Event</th><th>Files</th><th>Shortcode</th></tr></tfoot>'."\r\n".'<tbody>';
        foreach($results AS $row)
        {
            $edit='<a href="'.wp_nonce_url('admin.php?page=rm_podcasts/index.php&amp;action=edit_event&amp;id='.$row->event_id,'edit_podcast_event').'">Edit</a>';
            $delete='<a href="'.wp_nonce_url('admin.php?page=rm_podcasts/index.php&amp;action=delete_event&amp;id='.$row->event_id,'delete_podcast_event').'">Delete</a>';
            $files=$wpdb->get_var('SELECT count(*) FROM '.RM_POD_FIL.' WHERE event_id="'.esc_sql($row->event_id).'"');
            if(!$files)$files="0";
            $table.='<tr><td>'.$edit.'</td><td>'.$delete.'</td><td>'.esc_html($row->event_name).'</td><td>'.$files.'</td><td>[RM_PODCAST event_id="'.$row->event_id.'"]</td></tr>';
        }
        
        $table.='</tbody></table>';
        echo $table;
    }//end results
    else
    {
        echo'<p>No events stored yet</p>';
    }

}


function rm_podcast_edit_event($id=NULL)
{
    /**
 *
 * Edit podcast events
 * 
 * @author  Andy Moyle
 * @param    $id=null
 * @return   html string
 * @version  0.1
 * 
 */
    global $wpdb;
    if(!empty($id))
    {
        $current_data=$wpdb->get_row('SELECT * FROM '.RM_POD_EVE.' WHERE event_id="'.esc_sql($id).'"');
        $title='Edit';
    }
    else
    {
        $title='Add';
    }
    echo'<h2>'.$title.' event</h2>';
    if(!empty($_POST['save_event']))
    {//process form
        $event_name=esc_sql(stripslashes($_POST['event_name']));
        $event_description=esc_sql(stripslashes($_POST['event_dsecription']));
        if(empty($id))$id=$wpdb->get_var('SELECT event_id FROM '.RM_POD_EVE.' WHERE event_name="'.$event_name.'" AND event_description="'.$event_description.'"');
        if(!empty($id))
        {//update
            $wpdb->query('UPDATE '.RM_POD_EVE.' SET event_name="'.$event_name.'",event_description="'.$event_description.'" WHERE event_id="'.esc_sql($id).'"');
        }//end update
        else
        {//insert
            $wpdb->query('INSERT INTO '.RM_POD_EVE.' (event_name,event_description)VALUES("'.$event_name.'","'.$event_description.'")');
        }//end insert
        echo'<div class="updated fade"><p>Event Saved</p></div>';
        rm_podcast_list_events();
    }//end process form
    else
    {//form
        echo '<form action="" method="POST">';
        echo'<p><label for="event_name">Event Name</label><input type="text" name="event_name" id="event_name" ';
        if(!empty($current_data->event_name)) echo 'value="'.esc_html($current_data->event_name).'"';
        echo'/></p>';
        echo'<p><label for="event_description">Event Description</label></p>';
        echo'<textarea name="event_description" id="event_description">'.$current_data->event_description.'</textarea></p>';
        echo '<p><input type="hidden" name="save_event" value="save_event"/><input type="submit" class="primary-button" value="Save event"/></p></form>';
    }//form
    
    
}



?>