<?php


function rm_podcast_list_files()
{
/**
 *
 * Lists podcast files
 * 
 * @author  Andy Moyle
 * @param    null
 * @return   html string
 * @version  0.1
 * 
 */    
    global $wpdb;
    $wpdb->show_errors();

    echo'<h2>RM Podcast Files</h2>';
    echo '<p><a href="'.wp_nonce_url('admin.php?page=rm_podcasts/index.php&amp;action=edit_file','edit_podcast_file').'">Upload File</a></p>';
    echo '<p><a href="'.wp_nonce_url('admin.php?page=rm_podcasts/index.php&amp;action=check_files','check_podcast_file').'">Add Already Uploaded Files</a></p>';
    if(!file_exists(RM_POD_PTH.'podcast.xml'))
    {
        rm_podcast_xml();
        
    }
    if(file_exists(RM_POD_PTH.'podcast.xml'))echo'<p><a href="'.RM_POD_URL.'podcast.xml">Podcast RSS File</a></p>';
    //grab files from table
    $results=$wpdb->get_results('SELECT a.* FROM '.RM_POD_FIL.' a  ORDER BY pub_date DESC');
    if($results)
    {//results
        $table='<table class="widefat"><thead><tr><th>Edit</th><th>Delete</th><th>Publ. Date</th><th>Title</th><th>File</th><th>File Okay?</th><th>Length</th><th>Event</th><th>Shortcode</th></tr></thead>'."\r\n".'<tfoot><tr><th>Edit</th><th>Delete</th><th>Publ. Date</th><th>Title</th><th>File</th><th>File Okay?</th><th>Length</th><th>Event</th><th>Shortcode</th></tr></tfoot>'."\r\n".'<tbody>';
        foreach($results AS $row)
        {
            if(file_exists(RM_POD_PTH.$row->file_name)){$okay='<img src="'.RM_POD_IMG_URL.'green.png" width="32" height="32"/>';}else{$okay='<img src="'.RM_POD_IMG_URL.'red.png" width="32" height="32"/>';}
            $edit='<a href="'.wp_nonce_url('admin.php?page=rm_podcasts/index.php&amp;action=edit_file&amp;id='.$row->file_id,'edit_podcast_file').'">Edit</a>';
            $delete='<a href="'.wp_nonce_url('admin.php?page=rm_podcasts/index.php&amp;action=delete_file&amp;id='.$row->file_id,'delete_podcast_file').'">Delete</a>';
            $event_name=$wpdb->get_var('SELECT event_name FROM '.RM_POD_EVE.' WHERE event_id="'.esc_sql($row->event_id).'"');
            if(file_exists(RM_POD_PTH.$row->file_name)){$file='<a href="'.RM_POD_URL.$row->file_name.'">'.esc_html($row->file_name).'</a>';}else{$file='&nbsp;';}
            $table.='<tr><td>'.$edit.'</td><td>'.$delete.'</td><td>'.date(get_option('date_format'),strtotime($row->pub_date)).'</td><td>'.esc_html($row->file_title).'</td><td>'.$file.'</td><td>'.$okay.'</td><td>'.esc_html($row->length).'</td><td>'.$event_name.'</td><td>[RM_PODCAST file_id="'.$row->file_id.'"]</td></tr>';
        }
        
        $table.='</tbody></table>';
        echo $table;
    }//end results
    else
    {
        echo'<p>No files stored yet</p>';
    }

}

function rm_podcast_edit_file($id=NULL)
{
  /**
 *
 * Edit podcast file
 * 
 * @author  Andy Moyle
 * @param    $id=null
 * @return   html string
 * @version  0.1
 * 
 */
    global $wpdb;
    $wpdb->show_errors();
    if(!empty($id))
    {
        $current_data=$wpdb->get_row('SELECT * FROM '.RM_POD_FIL.' WHERE file_id="'.esc_sql($id).'"');
        $title='Edit';
    }
    else
    {
        $title='Add';
    }
    echo'<h2>'.$title.' File</h2>';
    if(!empty($_POST['save_file']))
    {//process form
        //handle upload
        //handle image
        $arr_file_type = wp_check_filetype(basename($_FILES['file']['name']));
        $uploaded_file_type = $arr_file_type['type'];
       
        // Set an array containing a list of acceptable formats
        $allowed_file_types = array( 'audio/mpeg','audio/mpeg3','audio/x-mpeg-3','video/mpeg','video/x-mpeg','application/pdf');
        // If the uploaded file is the right format
        if(in_array($uploaded_file_type, $allowed_file_types))
        {//valid image
            $tmp_name = $_FILES["file"]["tmp_name"];
            $name = $_FILES["file"]["name"];
            $x=1;
            $type=substr($name,-3);
            $split=sanitize_title(substr($name,0,-4));
            $file_name=$split.'.'.$type;
            while(file_exists(RM_POD_PTH.$file_name))
            {
                
                $file_name=$split.$x.'.'.$type;
                $x++;
            }
            
            if(!move_uploaded_file($tmp_name, RM_POD_PTH.$file_name)) echo"<p>File Upload issue</p>";
             
        }    
        if(empty($file_name) &&!empty($current_data->file_name))$file_name=$current_data->file_name;   
            require_once(RM_POD_INC.'mp3.php');
            $m = new mp3file(RM_POD_PTH.$file_name);
            $a = $m->get_metadata();
            $length=esc_sql($a['Length mm:ss']);
        
           
        //end handle upload
        unset($_POST['file']);
        foreach($_POST AS $key=>$value){$sqlsafe[$key]=esc_sql(stripslashes($value));}
        if(!empty($_POST['private'])){$private="1";}else{$private="0";}
        if(empty($_POST['pub_date'])){$pub_date=date("Y-m-d H:i:s" );}else{$pub_date=date("Y-m-d H:i:s",strtotime($_POST['pub_date']) );}
        if(empty($id))$id=$wpdb->get_var('SELECT file_id FROM '.RM_POD_FIL.' WHERE length="'.$length.'" AND private="'.$private.'" AND file_name="'.$filename.'" AND file_title="'.$sqlsafe['file_title'].'" AND file_description="'.$sqlsafe['file_description'].'" AND event_id="'.$sqlsafe['event_id'].'" AND speaker_id="'.$sqlsafe['speaker_id'].'"');
        if(!empty($id))
        {//update
            $wpdb->query('UPDATE '.RM_POD_FIL.' SET pub_date="'.$sqlsafe['pub_date'].'",length="'.$length.'", private="'.$private.'",last_modified="'.date("Y-m-d H:i:s" ).'",file_name="'.$file_name.'" , file_title="'.$sqlsafe['file_title'].'" , file_description="'.$sqlsafe['file_description'].'" , event_id="'.$sqlsafe['event_id'].'" , speaker_id="'.$sqlsafe['speaker_id'].'" WHERE file_id="'.esc_sql($id).'"');
        }//end update
        else
        {//insert
            $wpdb->query('INSERT INTO '.RM_POD_FIL.' (file_name,file_title,file_description,private,length,event_id,speaker_id,pub_date,last_modified)VALUES("'.$file_name.'","'.$sqlsafe['file_title'].'","'.$sqlsafe['file_description'].'" ,"'.$private.'","'.$length.'","'.$sqlsafe['event_id'].'","'.$sqlsafe['speaker_id'].'" ,"'.$sqldafe['pub_date'].'","'.date("Y-m-d H:i:s" ).'")');
        }//end insert
        rm_podcast_xml();//update podcast feed
        echo'<div class="updated fade"><p>File '.esc_html($file_name).' Saved</p></div>';
        rm_podcast_list_files();
    }//end process form
    else
    {//form
        $max_upload = (int)(ini_get('upload_max_filesize'));
        $max_post = (int)(ini_get('post_max_size'));
        $memory_limit = (int)(ini_get('memory_limit'));
        $upload_mb = min($max_upload, $max_post, $memory_limit);
        echo'<p>You can upload a file up to '.$upload_mb.'MB </p>';
        echo '<form action="" method="POST"  enctype="multipart/form-data">';
        echo'<p><label for="file_title">File Title</label><input type="text" name="file_title" id="file_title" ';
        if(!empty($current_data->file_title)) echo 'value="'.esc_html($current_data->file_title).'"';
        echo'/></p>';
        echo'<p><label for="file_description">File Description</label></p>';
        echo '<textarea name="file_description">'.esc_html($current_data->file_description).'</textarea></p>';
        echo'<p><label for="private">Logged in only?</label><input type="checkbox" name="private" value="yes"/></p>';
        $ev_res=$wpdb->get_results('SELECT * FROM '.RM_POD_EVE.' ORDER BY event_id DESC');
        if($ev_res)
        {
            echo'<p><label for="event">Event</label><select name="event_id">';
            $first=$option='';
            foreach($ev_res AS $ev_row)
            {
                if($ev_row->event_id==$current_data->event_id)
                {
                    $first='<option value="'.$ev_row->event_id.'" selected="selected">'.esc_html($ev_row->event_name).'</option>';
                }
                else
                {
                    $option.='<option value="'.$ev_row->event_id.'">'.esc_html($ev_row->event_name).'</option>';
                }
                
            }
            echo $first.$option.'</select></p>';
        }
        $sp_res=$wpdb->get_results('SELECT * FROM '.RM_POD_SPK.' ORDER BY speaker_name ASC');
        if($sp_res)
        {
            echo'<p><label for="speaker">Speaker</label><select name="speaker_id">';
            $first=$option='';
            foreach($sp_res AS $sp_row)
            {
                if($sp_row->speaker_id==$current_data->speaker_id)
                {
                    $first='<option value="'.$sp_row->speaker_id.'" selected="selected">'.esc_html($sp_row->speaker_name).'</option>';
                }
                else
                {
                    $option.='<option value="'.$sp_row->speaker_id.'">'.esc_html($sp_row->speaker_name).'</option>';
                }
                
            }
            echo $first.$option.'</select></p>';
        }
        if(empty($current_data->pub_date))$current_data->pub_date=date('Y-m-d H:i:s');
        echo'<p><label for="file">Publication Date</label><input type="text" name="pub_date" value="'.esc_html($current_data->pub_date).'"/></p>';
        echo'<p><label for="file">File to Upload</label><input type="file" name="file" id="file"/></p>';
        echo '<p><input type="hidden" name="save_file" value="save_file"/><input type="submit" class="primary-button" value="Save File"/></p></form>';
    }//form
    
    
}

function rm_podcast_delete_file($id=NULL)
{
  /**
 *
 * Delete File
 * 
 * @author  Andy Moyle
 * @param    $id=null
 * @return   html string
 * @version  0.1
 * 
 */
    global $wpdb;
    if(!empty($id))
    {//non empty $id
        $data=$wpdb->get_row('SELECT a.*,b.event_name AS event_name FROM '.RM_POD_FIL.' a , '.RM_POD_EVE.' b WHERE a.file_id="'.esc_sql($id).'" AND a.event_id=b.event_id');
        if(!empty($_POST['sure']))
        {//end sure so delete
            unlink(RM_POD_PTH.$data->file_name);
            $wpdb->query('DELETE FROM '.RM_POD_FIL.' WHERE file_id="'.esc_sql($id).'"');
            rm_podcast_xml();//update podcast feed
            echo'<div class="updated fade">'.$data->file_title.' from '.$data->event_name.' deleted</p></div>';
            rm_podcast_list_files();
        }//end sure so delete
        else
        {
            echo'<p>Are you sure you want to delete '.$data->file_title.' from '.$data->event_name.'? ';
            echo'<form action="" method="post"><input type="hidden" name="sure" value="YES"/><input type="submit" value="Yes" class="primary-button"/></form></p>';
        }
        
    }//end non empty $id
    else{echo'<p>No file specified '.$id.'</p>';}
}

function rm_podcast_check_files()
{
    /**
 *
 * Checks Files in media directory, table of non db stored files
 * 
 * @author  Andy Moyle
 * @param    $id=null
 * @return   html string
 * @version  0.1
 * 
 */
    global $wpdb;
    $wpdb->show_errors();
    $files=scandir(RM_POD_PTH);
    $exclude_list = array(".", "..", "index.php");
    $files = array_diff($files, $exclude_list);
    $table='<h2>Unattached Media Files</h2><table class="widefat"><thead><tr><th>Delete</th><th>Filename</th><th>Add to podcast</th></tr></thead><tfoot><tr><th>Delete</th><th>Filename</th><th>Add to podcast</th></tr></tfoot><tbody>';
    
    foreach($files as $entry)
    {
        $check=$wpdb->get_var('SELECT file_id FROM '.RM_POD_FIL.' WHERE file_name="'.esc_sql(basename($entry)).'"');
        
        if(is_file(RM_POD_PTH.$entry)&&!$check)
        {
            
            $delete='<a href="'.wp_nonce_url('admin.php?page=rm_podcasts/index.php&amp;action=file_delete&file='.$entry,'file_delete').'">Delete</a>';
            $add='<a href="'.wp_nonce_url('admin.php?page=rm_podcasts/index.php&amp;action=file_add&file='.$entry,'file_add').'">Add to podcast</a>';
            $table.='<tr><td>'.$delete.'</td><td>'.$entry.' '.$check.'</td><td>'.$add.'</td></tr>';
        }
    }
    $table.='</tbody>';
    echo $table;
    
}

function rm_podcast_file_add($file_name=NULL)
{
  /**
 *
 * Edit podcast file from directory to podcasts
 * 
 * @author  Andy Moyle
 * @param    $id=null
 * @return   html string
 * @version  0.1
 * 
 */
    if(!$file_name)wp_die("No file specified");
    global $wpdb;
    $wpdb->show_errors();
    $file_name=basename($file_name);
    echo'<h2>Add File - '.$file_name.'</h2>';
    if(!empty($_POST['save_file']))
    {//process form
        require_once(RM_POD_INC.'mp3.php');
        
        $m = new mp3file(RM_POD_PTH.$file_name);
        $a = $m->get_metadata();
        $length=esc_sql($a['Length mm:ss']);
        
        foreach($_POST AS $key=>$value){$sqlsafe[$key]=esc_sql(stripslashes($value));}
        if(empty($_POST['pub_date'])){$pub_date=date("Y-m-d H:i:s" );}else{$pub_date=date("Y-m-d H:i:s",strtotime($_POST['pub_date']) );}
        if(!empty($_POST['private'])){$private="1";}else{$private="0";}
        if(empty($id))$id=$wpdb->get_var('SELECT file_id FROM '.RM_POD_FIL.' WHERE file_name="'.$file_name.'"' );
        if(!empty($id))
        {//update
            $wpdb->query('UPDATE '.RM_POD_FIL.' SET pub_date="'.$pub_date.'", length="'.$length.'", last_modified="'.date("Y-m-d H:i:s" ).'",private="'.$private.'",file_name="'.$file_name.'" , file_title="'.$sqlsafe['file_title'].'" , file_description="'.$sqlsafe['file_description'].'" , event_id="'.$sqlsafe['event_id'].'" , speaker_id="'.$sqlsafe['speaker_id'].'" WHERE file_id="'.esc_sql($id).'"');
        }//end update
        else
        {//insert
            $wpdb->query('INSERT INTO '.RM_POD_FIL.' (file_name,file_title,file_description,private,length,event_id,speaker_id,pub_date,last_modified)VALUES("'.$file_name.'","'.$sqlsafe['file_title'].'","'.$sqlsafe['file_description'].'" ,"'.$private.'","'.$length.'","'.$sqlsafe['event_id'].'","'.$sqlsafe['speaker_id'].'" ,"'.$pub_date.'","'.date("Y-m-d H:i:s" ).'")');
        }//end insert
        rm_podcast_xml();//update podcast feed
        echo'<div class="updated fade"><p>File Saved</p></div>';
        rm_podcast_list_files();
    }//end process form
    else
    {//form
        echo '<form action="" method="POST"  enctype="multipart/form-data">';
        echo'<p><label for="file_title">File Title</label><input type="text" name="file_title" id="file_title" ';
        if(!empty($current_data->file_title)) echo 'value="'.esc_html($current_data->file_title).'"';
        echo'/></p>';
        echo'<p><label for="file_description">File Description</label></p>';
        echo '<textarea name="file_description">'.esc_html($current_data->file_description).'</textarea></p>';
        echo'<p><label for="private">Logged in only?</label><input type="checkbox" name="private" value="yes"/></p>';
        $ev_res=$wpdb->get_results('SELECT * FROM '.RM_POD_EVE.' ORDER BY event_id DESC');
        if($ev_res)
        {
            echo'<p><label for="event">Event</label><select name="event_id">';
            $first=$option='';
            foreach($ev_res AS $ev_row)
            {
                if($ev_row->event_id==$current_data->event_id)
                {
                    $first='<option value="'.$ev_row->event_id.'" selected="selected">'.esc_html($ev_row->event_name).'</option>';
                }
                else
                {
                    $option.='<option value="'.$ev_row->event_id.'">'.esc_html($ev_row->event_name).'</option>';
                }
                
            }
            echo $first.$option.'</select></p>';
        }
        $sp_res=$wpdb->get_results('SELECT * FROM '.RM_POD_SPK.' ORDER BY speaker_name ASC');
        if($sp_res)
        {
            echo'<p><label for="speaker">Speaker</label><select name="speaker_id">';
            $first=$option='';
            foreach($sp_res AS $sp_row)
            {
                if($sp_row->speaker_id==$current_data->speaker_id)
                {
                    $first='<option value="'.$sp_row->speaker_id.'" selected="selected">'.esc_html($sp_row->speaker_name).'</option>';
                }
                else
                {
                    $option.='<option value="'.$sp_row->speaker_id.'">'.esc_html($sp_row->speaker_name).'</option>';
                }
                
            }
            echo $first.$option.'</select></p>';
        }
        if(empty($current_data->pub_date))$current_data->pub_date=date('Y-m-d H:i:s');
        echo'<p><label for="file">Publication Date</label><input type="text" name="pub_date" value="'.esc_html($current_data->pub_date).'"/></p>';
        
        echo '<p><input type="hidden" name="save_file" value="save_file"/><input type="submit" class="primary-button" value="Save File"/></p></form>';
    }//form
    
    
}
function rm_podcast_file_delete($file_name=NULL)
{
    if($file_name &&is_file(RM_POD_PTH.basename($file_name)))
    {
        unlink(RM_POD_PTH.basename($file_name));
        echo'<div class="updated fade"><p>'.basename($file_name).' deleted</p></div>';
        rm_podcast_check_files();
    }
}


function rm_podcast_xml()
{
    global $wpdb;
    $settings=get_option('rm_podcast_settings');
     $results=$wpdb->get_results('SELECT DATE_FORMAT(a.pub_date,"%a, %d %b %Y %T") AS publ_date,a.*,b.speaker_name AS speaker_name,c.event_name AS event_name FROM '. RM_POD_FIL.' a,'.RM_POD_SPK .' b, '.RM_POD_EVE.' c WHERE a.private="0" AND a.speaker_id=b.speaker_id AND a.event_id=c.event_id ORDER BY pub_date DESC');
    if(!empty($results)&&!empty($settings['title']))
    {
 
        //CONSTRUCT RSS FEED HEADERS
        $output = '<rss xmlns:itunes="http://www.itunes.com/dtds/podcast-1.0.dtd" version="2.0">';
        $output .= '<channel>';
        $output .= '<title>'.$settings['title'].'</title>';
        $output .= '<link>'.RM_POD_URL.'podcast.xml'.'</link>';
        $output .= '<language>'.$settings['language'].'</language>';
        $output .= '<copyright>&#x2117; &amp; &#xA9; '.date('Y').' '.$settings['copyright'].'</copyright>';
        $output .= '<itunes:subtitle>'.$settings['subtitle'].'</itunes:subtitle>';
        $output .= '<itunes:author>'.$settings['author'].'</itunes:author>';
        $output .= '<itunes:summary>'.$settings['summary'].'</itunes:summary>';
        $output .= '<description>'.$settings['description'].'</description>';
        $output .= '<itunes:owner>';
        if(!empty($settings['owner_name']))$output .= '<itunes:name>'.$settings['owner_name'].'</itunes:name>';
        if(!empty($settings['owner_email']))$output .= '<itunes:email>'.$settings['owner_email'].'</itunes:email>';
        $output .= '</itunes:owner>';
        $output .= '<itunes:explicit>'.$settings['explicit'].'</itunes:explicit>';
       
        $output .='<itunes:image href="'.$settings['image'].'" />';
        if(!empty($settings['category']))
        {
            $cat=explode(" - ",$settings['category']);
            if(count($cat)==2){$output .='<itunes:category text="'.$cat[0].'"><itunes:category text="'.$cat[1].'"/></itunes:category>';}
            elseif(count($cat)==1){$output .='<itunes:category text="'.$cat[0].'"/>';}
            
        }
       
            //BODY OF RSS FEED
        foreach($results AS $row)
        {
            $output .= '<item>';
            $output .= '<title>'.$row->file_title.'</title>';
            $output .= '<itunes:author>'.$row->speaker_name.'</itunes:author>';
            $output .= '<itunes:subtitle></itunes:subtitle>';
            $output .= '<itunes:summary>'.$row->file_description.'</itunes:summary>';
            //$output .=  '<itunes:image href="'..'" />';
            $output .= '<enclosure url="'.RM_POD_URL.$row->file_name.'" length="'.filesize(RM_POD_PTH.$row->file_name).'" type="audio/mpeg" />';
            $output .= '<guid>'.RM_POD_URL.$row->file_name.'</guid>';
            $output .= '<pubDate>'.$row->publ_date.' '.date('O').'</pubDate>';
            $output .= '<itunes:duration>'.$row->length.'</itunes:duration>';
            //$output .= '<itunes:keywords></itunes:keywords>';
            $output .= '</item>';
        }
        //CLOSE RSS FEED
        $output .= '</channel>';
        $output .= '</rss>';
        
        //SEND COMPLETE RSS FEED TO podcast xml file
        $fp = fopen(RM_POD_PTH.'podcast.xml', 'w');
        fwrite($fp, $output);
        fclose($fp);
        return TRUE;
    }//end results
}
?>