<?php

function rm_podcast_list_speakers()
{
/**
 *
 * Lists podcast speakers
 * 
 * @author  Andy Moyle
 * @param    null
 * @return   html string
 * @version  0.1
 * 
 */    
    global $wpdb;
    $wpdb->show_errors();

    echo'<h2>RM Podcast Speakers</h2>';
    echo'<p><a href="'.wp_nonce_url('admin.php?page=rm_podcasts/index.php&amp;action=edit_speaker','edit_podcast_speaker').'">Add a speaker</a></p>';
    //grab files from table
    $results=$wpdb->get_results('SELECT * FROM '.RM_POD_SPK);
    if($results)
    {//results
        $table='<table class="widefat"><thead><tr><th>Edit</th><th>Delete</th><th>Speaker</th><th>Files</th><th>Shortcode</th></tr></thead>'."\r\n".'<tfoot><tr><th>Edit</th><th>Delete</th><th>Speaker</th><th>Files</th><th>Shortcode</th></tr></tfoot>'."\r\n".'<tbody>';
        foreach($results AS $row)
        {
            $edit='<a href="'.wp_nonce_url('admin.php?page=rm_podcasts/index.php&amp;action=edit_speaker&amp;id='.$row->file_id,'edit_podcast_speaker').'">Edit</a>';
            $delete='<a href="'.wp_nonce_url('admin.php?page=rm_podcasts/index.php&amp;action=delete_speaker&amp;id='.$row->file_id,'delete_podcast_speaker').'">Delete</a>';
            $files=$wpdb->get_var('SELECT count(*) FROM '.RM_POD_FIL.' WHERE speaker_id="'.esc_sql($row->speaker_id).'"');
            if(!$files)$files="0";
            $table.='<tr><td>'.$edit.'</td><td>'.$delete.'</td><td>'.esc_html($row->speaker_name).'</td><td>'.$files.'</td><td>[RM_PODCAST speaker_id="'.$row->speaker_id.'"]</td></tr>';
        }
        
        $table.='</tbody></table>';
        echo $table;
    }//end results
    else
    {
        echo'<p>No speakers stored yet</p>';
    }

}

function rm_podcast_edit_speaker($id=NULL)
{
    /**
 *
 * Edit podcast speakers
 * 
 * @author  Andy Moyle
 * @param    $id=null
 * @return   html string
 * @version  0.1
 * 
 */
    global $wpdb;
    if(!empty($id))
    {
        $current_data=$wpdb->get_row('SELECT * FROM '.RM_POD_SPK.' WHERE speaker_id="'.esc_sql($id).'"');
        $title='Edit';
    }
    else
    {
        $title='Add';
    }
    echo'<h2>'.$title.' Speaker</h2>';
    if(!empty($_POST['save_speaker']))
    {//process form
        $speaker_name=esc_sql(stripslashes($_POST['speaker_name']));
        if(empty($id))$id=$wpdb->get_var('SELECT speaker_id FROM '.RM_POD_SPK.' WHERE speaker_name="'.$speaker_name.'"');
        if(!empty($id))
        {//update
            $wpdb->query('UPDATE '.RM_POD_SPK.' SET speaker_name="'.$speaker_name.'" WHERE speaker_id="'.esc_sql($id).'"');
        }//end update
        else
        {//insert
            $wpdb->query('INSERT INTO '.RM_POD_SPK.' (speaker_name)VALUES("'.$speaker_name.'")');
        }//end insert
        echo'<div class="updated fade"><p>Speaker Saved</p></div>';
        rm_podcast_list_speakers();
    }//end process form
    else
    {//form
        echo '<form action="" method="POST">';
        echo'<p><label for="speaker_name">Speaker Name</label><input type="text" name="speaker_name" id="speaker_name" ';
        if(!empty($current_data->speaker_name)) echo 'value="'.esc_html($current_data->speaker_name).'"';
        echo'/></p>';
        echo '<p><input type="hidden" name="save_speaker" value="save_speaker"/><input type="submit" class="primary-button" value="Save Speaker"/></p></form>';
    }//form
    
    
}

?>